<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Course</title>
    
    <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/styles/default.min.css">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css" integrity="sha384-HSMxcRTRxnN+Bdg0JdbxYKrThecOKuH5zCYotlSAcp1+c8xmyTe9GYg1l9a69psu" crossorigin="anonymous">
    <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/highlight.min.js"></script>
    <script>hljs.initHighlightingOnLoad();</script>
</head>
<body>
    <h3>Fix the bad code:</h3>
    <pre class="prettyprint JavaScript">
        <code id="fixScript" contenteditable></code>
    </pre>
    
    <button id="btn-reset">Reset application</button>
    <button id="btn-fix">Apply security patch</button>

    <input type="text" placeholder="Command" id="itemInput">
    <button id="btn-test">Test address</button>

    <button id="btn-exec-sast">Scan for vulnerabilities</button><br>
    <p id="sast-return"></p>

    <h3>Current API response for: <br>'address = "<p id="itemNamePlaceholder">"'</h3>
    <pre class="prettyprint json">
        <code id="currentResult" contenteditable></code>
    </pre>
    
    <script>
        function parseJSON(res) {
            return res.json();
        }
        
        const ACTIONS = {
            "EXPLOIT": (data) => {
                currentResultElement.innerHTML = JSON.stringify(data, null, 2);
            },
            "RESET": (data) => {
                API.getActualScript();
            }
        }
        
        function sendAction(action) {
            if (Object.keys(ACTIONS).indexOf(action) != -1) {
                itemNamePlaceholder.innerText = itemName.value;

                fetch("/execute", {
                    method: "POST",
                    body: JSON.stringify({
                        action,
                        parameters: {
                            itemName: itemName.value,
                        },
                    }),
                })
                .then(parseJSON)
                .then(ACTIONS[action])
                .catch(console.log);
            } else {
                alert("Invalid action called.");
            }
        }
        
        const API = {
            submitQuery: () => {
                sendAction("EXPLOIT");
            },
            resetApplication: () => {
                sendAction("RESET");
            },
            patch: () => {
                fetch("/applyPatch", {
                    method: "POST",
                    body: JSON.stringify({
                        patch: fixScript.innerText,
                    }),
                })
                .then(parseJSON)
                .then((data) => {
                    API.getActualScript();
                })
                .catch(console.log);
            },
            getActualScript: () => {
                fetch("/script", {
                    method: "GET",
                })
                .then(parseJSON)
                .then((data) => {
                    fixScript.innerText = data.scriptData;
                })
                .catch(console.log);
            },
            execSAST: () => {
                fetch("/execSonar", {
                    method: "GET",
                })
                .then(parseJSON)
                .then(data => {
                    if (Object.keys(data).indexOf("data") !== -1) {
                        sastReturnLabel.innerText = data.data;
                    } else {
                        sastReturnLabel.innerText = data.error;
                    }
                })
                .catch(console.log);
            }
        };
        
        const testButton = document.getElementById("btn-test");
        const resetButton = document.getElementById("btn-reset");
        const fixButton = document.getElementById("btn-fix");
        const sastButton = document.getElementById("btn-exec-sast");
        
        const fixScript = document.getElementById("fixScript");
        const itemName = document.getElementById("itemInput");
        const currentResultElement = document.getElementById("currentResult");
        const itemNamePlaceholder = document.getElementById("itemNamePlaceholder");
        const sastReturnLabel = document.getElementById("sast-return");
        
        API.getActualScript();
        
        testButton.onclick = API.submitQuery;
        fixButton.onclick = API.patch;
        resetButton.onclick = API.resetApplication;
        sastButton.onclick = API.execSAST;
    </script>
</body>
</html>